"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const EntityLoader_1 = __importDefault(require("./EntityLoader"));
/**
 * The primary entry point for loading entities.
 */
class EntityLoaderFactory {
    constructor(entityConfiguration, entityClass, privacyPolicyClass, dataManager) {
        this.entityConfiguration = entityConfiguration;
        this.entityClass = entityClass;
        this.privacyPolicyClass = privacyPolicyClass;
        this.dataManager = dataManager;
    }
    /**
     * Vend loader for loading an entity in a given query context.
     * @param viewerContext - viewer context of loading user
     * @param queryContext - query context in which to perform the load
     */
    forLoad(viewerContext, queryContext) {
        return new EntityLoader_1.default(viewerContext, queryContext, this.entityConfiguration, this.entityClass, this.privacyPolicyClass, this.dataManager);
    }
}
exports.default = EntityLoaderFactory;
//# sourceMappingURL=EntityLoaderFactory.js.map