"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ViewerScopedEntityCompanion_1 = __importDefault(require("./ViewerScopedEntityCompanion"));
/**
 * Provides viewer-scoped entity companions providers for a simpler API.
 */
class ViewerScopedEntityCompanionProvider {
    constructor(entityCompanionProvider, viewerContext) {
        this.entityCompanionProvider = entityCompanionProvider;
        this.viewerContext = viewerContext;
    }
    /**
     * Vend a new viewer-scoped entity companion. If not already computed and cached, the entity
     * companion is constructed using the configuration provided by the factory.
     *
     * @param entityClass - entity class to load
     * @param factory - entity companion factory
     */
    getViewerScopedCompanionForEntity(entityClass, entityCompanionDefinition) {
        return new ViewerScopedEntityCompanion_1.default(this.entityCompanionProvider.getCompanionForEntity(entityClass, entityCompanionDefinition), this.viewerContext);
    }
}
exports.default = ViewerScopedEntityCompanionProvider;
//# sourceMappingURL=ViewerScopedEntityCompanionProvider.js.map