"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Provides a cleaner API for mutating entities by passing through the {@link ViewerContext}.
 */
class ViewerScopedEntityMutatorFactory {
    constructor(entityMutatorFactory, viewerContext) {
        this.entityMutatorFactory = entityMutatorFactory;
        this.viewerContext = viewerContext;
    }
    forCreate(queryContext) {
        return this.entityMutatorFactory.forCreate(this.viewerContext, queryContext);
    }
    forUpdate(existingEntity, queryContext) {
        return this.entityMutatorFactory.forUpdate(existingEntity, queryContext);
    }
    forDelete(existingEntity, queryContext) {
        return this.entityMutatorFactory.forDelete(existingEntity, queryContext);
    }
}
exports.default = ViewerScopedEntityMutatorFactory;
//# sourceMappingURL=ViewerScopedEntityMutatorFactory.js.map