"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Entity_1 = __importDefault(require("../Entity"));
const EntityCompanionProvider_1 = __importStar(require("../EntityCompanionProvider"));
const EntityConfiguration_1 = __importDefault(require("../EntityConfiguration"));
const EntityFields_1 = require("../EntityFields");
const EntityPrivacyPolicy_1 = __importDefault(require("../EntityPrivacyPolicy"));
const createUnitTestEntityCompanionProvider_1 = require("../utils/testing/createUnitTestEntityCompanionProvider");
const blahConfiguration = new EntityConfiguration_1.default({
    idField: 'hello',
    tableName: 'wat',
    schema: {
        hello: new EntityFields_1.StringField({
            columnName: 'hello',
        }),
    },
    databaseAdapterFlavor: 'postgres',
    cacheAdapterFlavor: 'redis',
});
class Blah1Entity extends Entity_1.default {
    static getCompanionDefinition() {
        return blah1CompanionDefinition;
    }
}
class Blah2Entity extends Entity_1.default {
    static getCompanionDefinition() {
        return blah2CompanionDefinition;
    }
}
class NoOpTest1PrivacyPolicy extends EntityPrivacyPolicy_1.default {
}
class NoOpTest2PrivacyPolicy extends EntityPrivacyPolicy_1.default {
}
const blah1CompanionDefinition = new EntityCompanionProvider_1.EntityCompanionDefinition({
    entityClass: Blah1Entity,
    entityConfiguration: blahConfiguration,
    privacyPolicyClass: NoOpTest1PrivacyPolicy,
});
const blah2CompanionDefinition = new EntityCompanionProvider_1.EntityCompanionDefinition({
    entityClass: Blah2Entity,
    entityConfiguration: blahConfiguration,
    privacyPolicyClass: NoOpTest2PrivacyPolicy,
});
describe(EntityCompanionProvider_1.default, () => {
    it('returns different instances for different entity types, but share table data coordinators', () => {
        const entityCompanionProvider = createUnitTestEntityCompanionProvider_1.createUnitTestEntityCompanionProvider();
        const companion1 = entityCompanionProvider.getCompanionForEntity(Blah1Entity, blah1CompanionDefinition);
        const companion2 = entityCompanionProvider.getCompanionForEntity(Blah2Entity, blah2CompanionDefinition);
        expect(companion1).not.toEqual(companion2);
        expect(companion1['tableDataCoordinator']).toEqual(companion2['tableDataCoordinator']);
    });
});
//# sourceMappingURL=EntityCompanionProvider-test.js.map