"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ts_mockito_1 = require("ts-mockito");
const Entity_1 = __importDefault(require("../Entity"));
const EntityCompanionProvider_1 = require("../EntityCompanionProvider");
const EntityConfiguration_1 = __importDefault(require("../EntityConfiguration"));
const EntityFields_1 = require("../EntityFields");
const EntityPrivacyPolicy_1 = __importStar(require("../EntityPrivacyPolicy"));
const EntityQueryContext_1 = require("../EntityQueryContext");
const ViewerContext_1 = __importDefault(require("../ViewerContext"));
const EntityNotAuthorizedError_1 = __importDefault(require("../errors/EntityNotAuthorizedError"));
const AlwaysAllowPrivacyPolicyRule_1 = __importDefault(require("../rules/AlwaysAllowPrivacyPolicyRule"));
const AlwaysDenyPrivacyPolicyRule_1 = __importDefault(require("../rules/AlwaysDenyPrivacyPolicyRule"));
const AlwaysSkipPrivacyPolicyRule_1 = __importDefault(require("../rules/AlwaysSkipPrivacyPolicyRule"));
const PrivacyPolicyRule_1 = __importDefault(require("../rules/PrivacyPolicyRule"));
class BlahEntity extends Entity_1.default {
    static getCompanionDefinition() {
        return blahEntityCompanionDefinition;
    }
}
class AlwaysDenyPolicy extends EntityPrivacyPolicy_1.default {
    constructor() {
        super(...arguments);
        this.createRules = [
            new AlwaysDenyPrivacyPolicyRule_1.default(),
        ];
        this.readRules = [
            new AlwaysDenyPrivacyPolicyRule_1.default(),
        ];
        this.updateRules = [
            new AlwaysDenyPrivacyPolicyRule_1.default(),
        ];
        this.deleteRules = [
            new AlwaysDenyPrivacyPolicyRule_1.default(),
        ];
    }
}
class DryRunAlwaysDenyPolicy extends AlwaysDenyPolicy {
    // public method for test spying
    denyHandler(_error) { }
    getPrivacyPolicyEvaluator() {
        return {
            mode: EntityPrivacyPolicy_1.EntityPrivacyPolicyEvaluationMode.DRY_RUN,
            denyHandler: this.denyHandler,
        };
    }
}
class LoggingEnforceAlwaysDenyPolicy extends AlwaysDenyPolicy {
    // public method for test spying
    denyHandler(_error) { }
    getPrivacyPolicyEvaluator() {
        return {
            mode: EntityPrivacyPolicy_1.EntityPrivacyPolicyEvaluationMode.ENFORCE_AND_LOG,
            denyHandler: this.denyHandler,
        };
    }
}
class AlwaysAllowPolicy extends EntityPrivacyPolicy_1.default {
    constructor() {
        super(...arguments);
        this.createRules = [
            new AlwaysAllowPrivacyPolicyRule_1.default(),
        ];
        this.readRules = [
            new AlwaysAllowPrivacyPolicyRule_1.default(),
        ];
        this.updateRules = [
            new AlwaysAllowPrivacyPolicyRule_1.default(),
        ];
        this.deleteRules = [
            new AlwaysAllowPrivacyPolicyRule_1.default(),
        ];
    }
}
class DryRunAlwaysAllowPolicy extends AlwaysAllowPolicy {
    // public method for test spying
    denyHandler(_error) { }
    getPrivacyPolicyEvaluator() {
        return {
            mode: EntityPrivacyPolicy_1.EntityPrivacyPolicyEvaluationMode.DRY_RUN,
            denyHandler: this.denyHandler,
        };
    }
}
class LoggingEnforceAlwaysAllowPolicy extends AlwaysAllowPolicy {
    // public method for test spying
    denyHandler(_error) { }
    getPrivacyPolicyEvaluator() {
        return {
            mode: EntityPrivacyPolicy_1.EntityPrivacyPolicyEvaluationMode.ENFORCE_AND_LOG,
            denyHandler: this.denyHandler,
        };
    }
}
class SkipAllPolicy extends EntityPrivacyPolicy_1.default {
    constructor() {
        super(...arguments);
        this.createRules = [
            new AlwaysSkipPrivacyPolicyRule_1.default(),
        ];
        this.readRules = [
            new AlwaysSkipPrivacyPolicyRule_1.default(),
        ];
        this.updateRules = [
            new AlwaysSkipPrivacyPolicyRule_1.default(),
        ];
        this.deleteRules = [
            new AlwaysSkipPrivacyPolicyRule_1.default(),
        ];
    }
}
class AlwaysThrowPrivacyPolicyRule extends PrivacyPolicyRule_1.default {
    evaluateAsync(_viewerContext, _queryContext, _entity) {
        throw new Error('WooHoo!');
    }
}
class ThrowAllPolicy extends EntityPrivacyPolicy_1.default {
    constructor() {
        super(...arguments);
        this.createRules = [new AlwaysThrowPrivacyPolicyRule()];
        this.readRules = [new AlwaysThrowPrivacyPolicyRule()];
        this.updateRules = [new AlwaysThrowPrivacyPolicyRule()];
        this.deleteRules = [new AlwaysThrowPrivacyPolicyRule()];
    }
}
class DryRunThrowAllPolicy extends ThrowAllPolicy {
    // public method for test spying
    denyHandler(_error) { }
    getPrivacyPolicyEvaluator() {
        return {
            mode: EntityPrivacyPolicy_1.EntityPrivacyPolicyEvaluationMode.DRY_RUN,
            denyHandler: this.denyHandler,
        };
    }
}
class LoggingEnforceThrowAllPolicy extends ThrowAllPolicy {
    // public method for test spying
    denyHandler(_error) { }
    getPrivacyPolicyEvaluator() {
        return {
            mode: EntityPrivacyPolicy_1.EntityPrivacyPolicyEvaluationMode.ENFORCE_AND_LOG,
            denyHandler: this.denyHandler,
        };
    }
}
class EmptyPolicy extends EntityPrivacyPolicy_1.default {
    constructor() {
        super(...arguments);
        this.createRules = [];
        this.readRules = [];
        this.updateRules = [];
        this.deleteRules = [];
    }
}
const blahEntityCompanionDefinition = new EntityCompanionProvider_1.EntityCompanionDefinition({
    entityClass: BlahEntity,
    entityConfiguration: new EntityConfiguration_1.default({
        idField: 'id',
        tableName: 'blah_table',
        schema: {
            id: new EntityFields_1.UUIDField({
                columnName: 'id',
            }),
        },
        databaseAdapterFlavor: 'postgres',
        cacheAdapterFlavor: 'redis',
    }),
    privacyPolicyClass: AlwaysDenyPolicy,
});
describe(EntityPrivacyPolicy_1.default, () => {
    it('throws EntityNotAuthorizedError when deny', async () => {
        const viewerContext = ts_mockito_1.instance(ts_mockito_1.mock(ViewerContext_1.default));
        const queryContext = ts_mockito_1.instance(ts_mockito_1.mock(EntityQueryContext_1.EntityQueryContext));
        const entity = new BlahEntity(viewerContext, { id: '1' });
        const policy = new AlwaysDenyPolicy();
        await expect(policy.authorizeCreateAsync(viewerContext, queryContext, entity)).rejects.toBeInstanceOf(EntityNotAuthorizedError_1.default);
    });
    it('returns entity when allowed', async () => {
        const viewerContext = ts_mockito_1.instance(ts_mockito_1.mock(ViewerContext_1.default));
        const queryContext = ts_mockito_1.instance(ts_mockito_1.mock(EntityQueryContext_1.EntityQueryContext));
        const entity = new BlahEntity(viewerContext, { id: '1' });
        const policy = new AlwaysAllowPolicy();
        const approvedEntity = await policy.authorizeCreateAsync(viewerContext, queryContext, entity);
        expect(approvedEntity).toEqual(entity);
    });
    it('throws EntityNotAuthorizedError when all skipped', async () => {
        const viewerContext = ts_mockito_1.instance(ts_mockito_1.mock(ViewerContext_1.default));
        const queryContext = ts_mockito_1.instance(ts_mockito_1.mock(EntityQueryContext_1.EntityQueryContext));
        const entity = new BlahEntity(viewerContext, { id: '1' });
        const policy = new SkipAllPolicy();
        await expect(policy.authorizeCreateAsync(viewerContext, queryContext, entity)).rejects.toBeInstanceOf(EntityNotAuthorizedError_1.default);
    });
    it('throws EntityNotAuthorizedError when empty policy', async () => {
        const viewerContext = ts_mockito_1.instance(ts_mockito_1.mock(ViewerContext_1.default));
        const queryContext = ts_mockito_1.instance(ts_mockito_1.mock(EntityQueryContext_1.EntityQueryContext));
        const entity = new BlahEntity(viewerContext, { id: '1' });
        const policy = new EmptyPolicy();
        await expect(policy.authorizeCreateAsync(viewerContext, queryContext, entity)).rejects.toBeInstanceOf(EntityNotAuthorizedError_1.default);
    });
    it('throws when rule throws', async () => {
        const viewerContext = ts_mockito_1.instance(ts_mockito_1.mock(ViewerContext_1.default));
        const queryContext = ts_mockito_1.instance(ts_mockito_1.mock(EntityQueryContext_1.EntityQueryContext));
        const entity = new BlahEntity(viewerContext, { id: '1' });
        const policy = new ThrowAllPolicy();
        await expect(policy.authorizeCreateAsync(viewerContext, queryContext, entity)).rejects.toThrowError('WooHoo!');
    });
    describe('dry run', () => {
        it('returns entity when denied but calls denialHandler', async () => {
            const viewerContext = ts_mockito_1.instance(ts_mockito_1.mock(ViewerContext_1.default));
            const queryContext = ts_mockito_1.instance(ts_mockito_1.mock(EntityQueryContext_1.EntityQueryContext));
            const entity = new BlahEntity(viewerContext, { id: '1' });
            const policy = new DryRunAlwaysDenyPolicy();
            const policySpy = ts_mockito_1.spy(policy);
            const approvedEntity = await policy.authorizeCreateAsync(viewerContext, queryContext, entity);
            expect(approvedEntity).toEqual(entity);
            ts_mockito_1.verify(policySpy.denyHandler(ts_mockito_1.anyOfClass(EntityNotAuthorizedError_1.default))).once();
        });
        it('does not log when not denied', async () => {
            const viewerContext = ts_mockito_1.instance(ts_mockito_1.mock(ViewerContext_1.default));
            const queryContext = ts_mockito_1.instance(ts_mockito_1.mock(EntityQueryContext_1.EntityQueryContext));
            const entity = new BlahEntity(viewerContext, { id: '1' });
            const policy = new DryRunAlwaysAllowPolicy();
            const policySpy = ts_mockito_1.spy(policy);
            const approvedEntity = await policy.authorizeCreateAsync(viewerContext, queryContext, entity);
            expect(approvedEntity).toEqual(entity);
            ts_mockito_1.verify(policySpy.denyHandler(ts_mockito_1.anyOfClass(EntityNotAuthorizedError_1.default))).never();
        });
        it('passes through other errors', async () => {
            const viewerContext = ts_mockito_1.instance(ts_mockito_1.mock(ViewerContext_1.default));
            const queryContext = ts_mockito_1.instance(ts_mockito_1.mock(EntityQueryContext_1.EntityQueryContext));
            const entity = new BlahEntity(viewerContext, { id: '1' });
            const policy = new DryRunThrowAllPolicy();
            const policySpy = ts_mockito_1.spy(policy);
            await expect(policy.authorizeCreateAsync(viewerContext, queryContext, entity)).rejects.toThrowError('WooHoo!');
            ts_mockito_1.verify(policySpy.denyHandler(ts_mockito_1.anyOfClass(EntityNotAuthorizedError_1.default))).never();
        });
    });
    describe('logging enforce', () => {
        it('denies when denied but calls denialHandler', async () => {
            const viewerContext = ts_mockito_1.instance(ts_mockito_1.mock(ViewerContext_1.default));
            const queryContext = ts_mockito_1.instance(ts_mockito_1.mock(EntityQueryContext_1.EntityQueryContext));
            const entity = new BlahEntity(viewerContext, { id: '1' });
            const policy = new LoggingEnforceAlwaysDenyPolicy();
            const policySpy = ts_mockito_1.spy(policy);
            await expect(policy.authorizeCreateAsync(viewerContext, queryContext, entity)).rejects.toBeInstanceOf(EntityNotAuthorizedError_1.default);
            ts_mockito_1.verify(policySpy.denyHandler(ts_mockito_1.anyOfClass(EntityNotAuthorizedError_1.default))).once();
        });
        it('does not log when not denied', async () => {
            const viewerContext = ts_mockito_1.instance(ts_mockito_1.mock(ViewerContext_1.default));
            const queryContext = ts_mockito_1.instance(ts_mockito_1.mock(EntityQueryContext_1.EntityQueryContext));
            const entity = new BlahEntity(viewerContext, { id: '1' });
            const policy = new LoggingEnforceAlwaysAllowPolicy();
            const policySpy = ts_mockito_1.spy(policy);
            const approvedEntity = await policy.authorizeCreateAsync(viewerContext, queryContext, entity);
            expect(approvedEntity).toEqual(entity);
            ts_mockito_1.verify(policySpy.denyHandler(ts_mockito_1.anyOfClass(EntityNotAuthorizedError_1.default))).never();
        });
        it('passes through other errors', async () => {
            const viewerContext = ts_mockito_1.instance(ts_mockito_1.mock(ViewerContext_1.default));
            const queryContext = ts_mockito_1.instance(ts_mockito_1.mock(EntityQueryContext_1.EntityQueryContext));
            const entity = new BlahEntity(viewerContext, { id: '1' });
            const policy = new LoggingEnforceThrowAllPolicy();
            const policySpy = ts_mockito_1.spy(policy);
            await expect(policy.authorizeCreateAsync(viewerContext, queryContext, entity)).rejects.toThrowError('WooHoo!');
            ts_mockito_1.verify(policySpy.denyHandler(ts_mockito_1.anyOfClass(EntityNotAuthorizedError_1.default))).never();
        });
    });
});
//# sourceMappingURL=EntityPrivacyPolicy-test.js.map