"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ts_mockito_1 = require("ts-mockito");
const ViewerContext_1 = __importDefault(require("../ViewerContext"));
const ViewerScopedEntityCompanion_1 = __importDefault(require("../ViewerScopedEntityCompanion"));
const ViewerScopedEntityLoaderFactory_1 = __importDefault(require("../ViewerScopedEntityLoaderFactory"));
const ViewerScopedEntityMutatorFactory_1 = __importDefault(require("../ViewerScopedEntityMutatorFactory"));
describe(ViewerScopedEntityCompanion_1.default, () => {
    it('returns viewer scoped loader and mutator factory', () => {
        const vc = ts_mockito_1.instance(ts_mockito_1.mock(ViewerContext_1.default));
        const entityCompanion = ts_mockito_1.mock();
        const viewerScopedEntityCompanion = new ViewerScopedEntityCompanion_1.default(entityCompanion, vc);
        expect(viewerScopedEntityCompanion.getLoaderFactory()).toBeInstanceOf(ViewerScopedEntityLoaderFactory_1.default);
        expect(viewerScopedEntityCompanion.getMutatorFactory()).toBeInstanceOf(ViewerScopedEntityMutatorFactory_1.default);
    });
});
//# sourceMappingURL=ViewerScopedEntityCompanion-test.js.map