"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ts_mockito_1 = require("ts-mockito");
const EntityLoaderFactory_1 = __importDefault(require("../EntityLoaderFactory"));
const EntityQueryContext_1 = require("../EntityQueryContext");
const ViewerContext_1 = __importDefault(require("../ViewerContext"));
const ViewerScopedEntityLoaderFactory_1 = __importDefault(require("../ViewerScopedEntityLoaderFactory"));
describe(ViewerScopedEntityLoaderFactory_1.default, () => {
    it('correctly scopes viewer to entity loads', async () => {
        const viewerContext = ts_mockito_1.instance(ts_mockito_1.mock(ViewerContext_1.default));
        const queryContext = ts_mockito_1.instance(ts_mockito_1.mock(EntityQueryContext_1.EntityQueryContext));
        const baseLoader = ts_mockito_1.mock(EntityLoaderFactory_1.default);
        const baseLoaderInstance = ts_mockito_1.instance(baseLoader);
        const viewerScopedEntityLoader = new ViewerScopedEntityLoaderFactory_1.default(baseLoaderInstance, viewerContext);
        viewerScopedEntityLoader.forLoad(queryContext);
        ts_mockito_1.verify(baseLoader.forLoad(viewerContext, queryContext)).once();
    });
});
//# sourceMappingURL=ViewerScopedEntityLoaderFactory-test.js.map