"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ts_mockito_1 = require("ts-mockito");
const EntityMutatorFactory_1 = __importDefault(require("../EntityMutatorFactory"));
const EntityQueryContext_1 = require("../EntityQueryContext");
const ViewerContext_1 = __importDefault(require("../ViewerContext"));
const ViewerScopedEntityMutatorFactory_1 = __importDefault(require("../ViewerScopedEntityMutatorFactory"));
describe(ViewerScopedEntityMutatorFactory_1.default, () => {
    it('correctly scopes viewer to entity mutations', async () => {
        const viewerContext = ts_mockito_1.instance(ts_mockito_1.mock(ViewerContext_1.default));
        const queryContext = ts_mockito_1.instance(ts_mockito_1.mock(EntityQueryContext_1.EntityQueryContext));
        const baseMutatorFactory = ts_mockito_1.mock(EntityMutatorFactory_1.default);
        const baseMutatorFactoryInstance = ts_mockito_1.instance(baseMutatorFactory);
        const viewerScopedEntityLoader = new ViewerScopedEntityMutatorFactory_1.default(baseMutatorFactoryInstance, viewerContext);
        viewerScopedEntityLoader.forCreate(queryContext);
        ts_mockito_1.verify(baseMutatorFactory.forCreate(viewerContext, queryContext)).once();
    });
});
//# sourceMappingURL=ViewerScopedEntityMutatorFactory-test.js.map