import EntityError, { EntityErrorCode, EntityErrorState } from './EntityError';
export default abstract class EntityDatabaseAdapterError extends EntityError {
}
export declare class EntityDatabaseAdapterTransientError extends EntityDatabaseAdapterError {
    readonly state = EntityErrorState.TRANSIENT;
    readonly code = EntityErrorCode.ERR_ENTITY_DATABASE_ADAPTER_TRANSIENT;
}
export declare class EntityDatabaseAdapterUnknownError extends EntityDatabaseAdapterError {
    readonly state = EntityErrorState.UNKNOWN;
    readonly code = EntityErrorCode.ERR_ENTITY_DATABASE_ADAPTER_UNKNOWN;
}
export declare class EntityDatabaseAdapterCheckConstraintError extends EntityDatabaseAdapterError {
    readonly state = EntityErrorState.PERMANENT;
    readonly code = EntityErrorCode.ERR_ENTITY_DATABASE_ADAPTER_CHECK_CONSTRAINT;
}
export declare class EntityDatabaseAdapterExclusionConstraintError extends EntityDatabaseAdapterError {
    readonly state = EntityErrorState.PERMANENT;
    readonly code = EntityErrorCode.ERR_ENTITY_DATABASE_ADAPTER_EXCLUSION_CONSTRAINT;
}
export declare class EntityDatabaseAdapterForeignKeyConstraintError extends EntityDatabaseAdapterError {
    readonly state = EntityErrorState.PERMANENT;
    readonly code = EntityErrorCode.ERR_ENTITY_DATABASE_ADAPTER_FOREIGN_KEY_CONSTRAINT;
}
export declare class EntityDatabaseAdapterNotNullConstraintError extends EntityDatabaseAdapterError {
    readonly state = EntityErrorState.PERMANENT;
    readonly code = EntityErrorCode.ERR_ENTITY_DATABASE_ADAPTER_NOT_NULL_CONSTRAINT;
}
export declare class EntityDatabaseAdapterUniqueConstraintError extends EntityDatabaseAdapterError {
    readonly state = EntityErrorState.PERMANENT;
    readonly code = EntityErrorCode.ERR_ENTITY_DATABASE_ADAPTER_UNIQUE_CONSTRAINT;
}
