import ES6Error from 'es6-error';
export declare enum EntityErrorState {
    UNKNOWN = 0,
    TRANSIENT = 1,
    PERMANENT = 2
}
export declare enum EntityErrorCode {
    ERR_ENTITY_NOT_AUTHORIZED = "ERR_ENTITY_NOT_AUTHORIZED",
    ERR_ENTITY_NOT_FOUND = "ERR_ENTITY_NOT_FOUND",
    ERR_ENTITY_INVALID_FIELD_VALUE = "ERR_ENTITY_INVALID_FIELD_VALUE",
    ERR_ENTITY_DATABASE_ADAPTER_TRANSIENT = "ERR_ENTITY_DATABASE_ADAPTER_TRANSIENT",
    ERR_ENTITY_DATABASE_ADAPTER_UNKNOWN = "ERR_ENTITY_DATABASE_ADAPTER_UNKNOWN",
    ERR_ENTITY_DATABASE_ADAPTER_CHECK_CONSTRAINT = "ERR_ENTITY_DATABASE_ADAPTER_CHECK_CONSTRAINT",
    ERR_ENTITY_DATABASE_ADAPTER_EXCLUSION_CONSTRAINT = "ERR_ENTITY_DATABASE_ADAPTER_EXCLUSION_CONSTRAINT",
    ERR_ENTITY_DATABASE_ADAPTER_FOREIGN_KEY_CONSTRAINT = "ERR_ENTITY_DATABASE_ADAPTER_FOREIGN_KEY_CONSTRAINT",
    ERR_ENTITY_DATABASE_ADAPTER_NOT_NULL_CONSTRAINT = "ERR_ENTITY_DATABASE_ADAPTER_NOT_NULL_CONSTRAINT",
    ERR_ENTITY_DATABASE_ADAPTER_UNIQUE_CONSTRAINT = "ERR_ENTITY_DATABASE_ADAPTER_UNIQUE_CONSTRAINT",
    ERR_ENTITY_CACHE_ADAPTER_TRANSIENT = "ERR_ENTITY_CACHE_ADAPTER_TRANSIENT"
}
export default abstract class EntityError extends ES6Error {
    readonly cause?: Error | undefined;
    abstract readonly state: EntityErrorState;
    abstract readonly code: EntityErrorCode;
    constructor(message: string, cause?: Error | undefined);
}
