import { EntityQueryContext } from '../EntityQueryContext';
import ReadonlyEntity from '../ReadonlyEntity';
import ViewerContext from '../ViewerContext';
import PrivacyPolicyRule, { RuleEvaluationResult } from './PrivacyPolicyRule';
/**
 * Privacy policy rule that always denies.
 */
export default class AlwaysDenyPrivacyPolicyRule<TFields, TID extends NonNullable<TFields[TSelectedFields]>, TViewerContext extends ViewerContext, TEntity extends ReadonlyEntity<TFields, TID, TViewerContext, TSelectedFields>, TSelectedFields extends keyof TFields = keyof TFields> extends PrivacyPolicyRule<TFields, TID, TViewerContext, TEntity, TSelectedFields> {
    evaluateAsync(_viewerContext: TViewerContext, _queryContext: EntityQueryContext, _entity: TEntity): Promise<RuleEvaluationResult>;
}
