"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.dateIDTestEntityCompanion = exports.DateIDTestEntityPrivacyPolicy = exports.dateIDTestEntityConfiguration = void 0;
const Entity_1 = __importDefault(require("../Entity"));
const EntityCompanionProvider_1 = require("../EntityCompanionProvider");
const EntityConfiguration_1 = __importDefault(require("../EntityConfiguration"));
const EntityFields_1 = require("../EntityFields");
const EntityPrivacyPolicy_1 = __importDefault(require("../EntityPrivacyPolicy"));
const AlwaysAllowPrivacyPolicyRule_1 = __importDefault(require("../rules/AlwaysAllowPrivacyPolicyRule"));
exports.dateIDTestEntityConfiguration = new EntityConfiguration_1.default({
    idField: 'id',
    tableName: 'simple_test_entity_should_not_write_to_db',
    schema: {
        id: new EntityFields_1.DateField({
            columnName: 'custom_id',
        }),
    },
    databaseAdapterFlavor: 'postgres',
    cacheAdapterFlavor: 'redis',
});
class DateIDTestEntityPrivacyPolicy extends EntityPrivacyPolicy_1.default {
    constructor() {
        super(...arguments);
        this.readRules = [
            new AlwaysAllowPrivacyPolicyRule_1.default(),
        ];
        this.createRules = [
            new AlwaysAllowPrivacyPolicyRule_1.default(),
        ];
        this.updateRules = [
            new AlwaysAllowPrivacyPolicyRule_1.default(),
        ];
        this.deleteRules = [
            new AlwaysAllowPrivacyPolicyRule_1.default(),
        ];
    }
}
exports.DateIDTestEntityPrivacyPolicy = DateIDTestEntityPrivacyPolicy;
class DateIDTestEntity extends Entity_1.default {
    static getCompanionDefinition() {
        return exports.dateIDTestEntityCompanion;
    }
}
exports.default = DateIDTestEntity;
exports.dateIDTestEntityCompanion = new EntityCompanionProvider_1.EntityCompanionDefinition({
    entityClass: DateIDTestEntity,
    entityConfiguration: exports.dateIDTestEntityConfiguration,
    privacyPolicyClass: DateIDTestEntityPrivacyPolicy,
});
//# sourceMappingURL=DateIDTestEntity.js.map