"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.testEntityCompanion = exports.SimpleTestEntityPrivacyPolicy = exports.simpleTestEntityConfiguration = void 0;
const Entity_1 = __importDefault(require("../Entity"));
const EntityCompanionProvider_1 = require("../EntityCompanionProvider");
const EntityConfiguration_1 = __importDefault(require("../EntityConfiguration"));
const EntityFields_1 = require("../EntityFields");
const EntityPrivacyPolicy_1 = __importDefault(require("../EntityPrivacyPolicy"));
const AlwaysAllowPrivacyPolicyRule_1 = __importDefault(require("../rules/AlwaysAllowPrivacyPolicyRule"));
exports.simpleTestEntityConfiguration = new EntityConfiguration_1.default({
    idField: 'id',
    tableName: 'simple_test_entity_should_not_write_to_db',
    schema: {
        id: new EntityFields_1.UUIDField({
            columnName: 'custom_id',
        }),
    },
    databaseAdapterFlavor: 'postgres',
    cacheAdapterFlavor: 'redis',
});
class SimpleTestEntityPrivacyPolicy extends EntityPrivacyPolicy_1.default {
    constructor() {
        super(...arguments);
        this.readRules = [
            new AlwaysAllowPrivacyPolicyRule_1.default(),
        ];
        this.createRules = [
            new AlwaysAllowPrivacyPolicyRule_1.default(),
        ];
        this.updateRules = [
            new AlwaysAllowPrivacyPolicyRule_1.default(),
        ];
        this.deleteRules = [
            new AlwaysAllowPrivacyPolicyRule_1.default(),
        ];
    }
}
exports.SimpleTestEntityPrivacyPolicy = SimpleTestEntityPrivacyPolicy;
class SimpleTestEntity extends Entity_1.default {
    static getCompanionDefinition() {
        return exports.testEntityCompanion;
    }
}
exports.default = SimpleTestEntity;
exports.testEntityCompanion = new EntityCompanionProvider_1.EntityCompanionDefinition({
    entityClass: SimpleTestEntity,
    entityConfiguration: exports.simpleTestEntityConfiguration,
    privacyPolicyClass: SimpleTestEntityPrivacyPolicy,
});
//# sourceMappingURL=SimpleTestEntity.js.map