import { Result } from '@expo/results';
import Entity from '../Entity';
import { EntityCompanionDefinition } from '../EntityCompanionProvider';
import EntityConfiguration from '../EntityConfiguration';
import EntityPrivacyPolicy from '../EntityPrivacyPolicy';
import ViewerContext from '../ViewerContext';
import AlwaysAllowPrivacyPolicyRule from '../rules/AlwaysAllowPrivacyPolicyRule';
export declare type TestFields = {
    customIdField: string;
    testIndexedField: string;
    stringField: string;
    intField: number;
    dateField: Date;
    nullableField: string | null;
};
export declare const testEntityConfiguration: EntityConfiguration<TestFields>;
export declare class TestEntityPrivacyPolicy extends EntityPrivacyPolicy<TestFields, string, ViewerContext, TestEntity> {
    protected readonly readRules: AlwaysAllowPrivacyPolicyRule<TestFields, string, ViewerContext, TestEntity, "customIdField" | "testIndexedField" | "stringField" | "intField" | "dateField" | "nullableField">[];
    protected readonly createRules: AlwaysAllowPrivacyPolicyRule<TestFields, string, ViewerContext, TestEntity, "customIdField" | "testIndexedField" | "stringField" | "intField" | "dateField" | "nullableField">[];
    protected readonly updateRules: AlwaysAllowPrivacyPolicyRule<TestFields, string, ViewerContext, TestEntity, "customIdField" | "testIndexedField" | "stringField" | "intField" | "dateField" | "nullableField">[];
    protected readonly deleteRules: AlwaysAllowPrivacyPolicyRule<TestFields, string, ViewerContext, TestEntity, "customIdField" | "testIndexedField" | "stringField" | "intField" | "dateField" | "nullableField">[];
}
export default class TestEntity extends Entity<TestFields, string, ViewerContext> {
    static getCompanionDefinition(): EntityCompanionDefinition<TestFields, string, ViewerContext, TestEntity, TestEntityPrivacyPolicy>;
    getBlah(): string;
    static hello(viewerContext: ViewerContext, testValue: string): Promise<Result<TestEntity>>;
    static returnError(_viewerContext: ViewerContext): Promise<Result<TestEntity>>;
    static throwError(_viewerContext: ViewerContext): Promise<Result<TestEntity>>;
    static nonResult(_viewerContext: ViewerContext, testValue: string): Promise<string>;
}
export declare const testEntityCompanion: EntityCompanionDefinition<TestFields, string, ViewerContext, TestEntity, TestEntityPrivacyPolicy, "customIdField" | "testIndexedField" | "stringField" | "intField" | "dateField" | "nullableField">;
