"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.testEntity2Companion = exports.TestEntity2PrivacyPolicy = exports.testEntity2Configuration = void 0;
const Entity_1 = __importDefault(require("../Entity"));
const EntityCompanionProvider_1 = require("../EntityCompanionProvider");
const EntityConfiguration_1 = __importDefault(require("../EntityConfiguration"));
const EntityFields_1 = require("../EntityFields");
const EntityPrivacyPolicy_1 = __importDefault(require("../EntityPrivacyPolicy"));
const AlwaysAllowPrivacyPolicyRule_1 = __importDefault(require("../rules/AlwaysAllowPrivacyPolicyRule"));
exports.testEntity2Configuration = new EntityConfiguration_1.default({
    idField: 'id',
    tableName: 'test_entity_should_not_write_to_db_2',
    schema: {
        id: new EntityFields_1.UUIDField({
            columnName: 'id',
        }),
        foreignKey: new EntityFields_1.UUIDField({
            columnName: 'foreign_key',
        }),
    },
    databaseAdapterFlavor: 'postgres',
    cacheAdapterFlavor: 'redis',
});
class TestEntity2PrivacyPolicy extends EntityPrivacyPolicy_1.default {
    constructor() {
        super(...arguments);
        this.readRules = [
            new AlwaysAllowPrivacyPolicyRule_1.default(),
        ];
        this.createRules = [
            new AlwaysAllowPrivacyPolicyRule_1.default(),
        ];
        this.updateRules = [
            new AlwaysAllowPrivacyPolicyRule_1.default(),
        ];
        this.deleteRules = [
            new AlwaysAllowPrivacyPolicyRule_1.default(),
        ];
    }
}
exports.TestEntity2PrivacyPolicy = TestEntity2PrivacyPolicy;
class TestEntity2 extends Entity_1.default {
    static getCompanionDefinition() {
        return exports.testEntity2Companion;
    }
}
exports.default = TestEntity2;
exports.testEntity2Companion = new EntityCompanionProvider_1.EntityCompanionDefinition({
    entityClass: TestEntity2,
    entityConfiguration: exports.testEntity2Configuration,
    privacyPolicyClass: TestEntity2PrivacyPolicy,
});
//# sourceMappingURL=TestEntity2.js.map