import Entity from '../Entity';
import { EntityCompanionDefinition } from '../EntityCompanionProvider';
import EntityConfiguration from '../EntityConfiguration';
import EntityPrivacyPolicy from '../EntityPrivacyPolicy';
import ViewerContext from '../ViewerContext';
import AlwaysAllowPrivacyPolicyRule from '../rules/AlwaysAllowPrivacyPolicyRule';
export declare type NumberKeyFields = {
    id: number;
};
export declare const numberKeyEntityConfiguration: EntityConfiguration<NumberKeyFields>;
export declare class NumberKeyPrivacyPolicy extends EntityPrivacyPolicy<NumberKeyFields, number, ViewerContext, NumberKeyEntity> {
    protected readonly readRules: AlwaysAllowPrivacyPolicyRule<NumberKeyFields, number, ViewerContext, NumberKeyEntity, "id">[];
    protected readonly createRules: AlwaysAllowPrivacyPolicyRule<NumberKeyFields, number, ViewerContext, NumberKeyEntity, "id">[];
    protected readonly updateRules: AlwaysAllowPrivacyPolicyRule<NumberKeyFields, number, ViewerContext, NumberKeyEntity, "id">[];
    protected readonly deleteRules: AlwaysAllowPrivacyPolicyRule<NumberKeyFields, number, ViewerContext, NumberKeyEntity, "id">[];
}
export default class NumberKeyEntity extends Entity<NumberKeyFields, number, ViewerContext> {
    static getCompanionDefinition(): EntityCompanionDefinition<NumberKeyFields, number, ViewerContext, NumberKeyEntity, NumberKeyPrivacyPolicy>;
}
export declare const numberKeyEntityCompanion: EntityCompanionDefinition<NumberKeyFields, number, ViewerContext, NumberKeyEntity, NumberKeyPrivacyPolicy, "id">;
